﻿Public Class Form1

    Private wp1 As WavePlayer = New WavePlayer

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        EventsAreEnabled = False
        Text = AppTitleAndVersion("")
        ' --------------------------------------------------------
        Combo_InitFromEnum(cmb_Gen1_Wave, GetType(WavePlayer.WaveTypes))
        cmb_Gen1_Wave.SelectedIndex = 0
        Load_INI()
        InitSlots
        FillAudioOutDevicesCombo()
        ' --------------------------------------------------------
        WaveGenTrim()
        WaveGenSetWaveTypes()
        If chk_Gen1.Checked Then
            wp1.PlayStart(SelectedAudioOut)
        Else
            wp1.PlayStop()
        End If
        ' -------------------------------------------------------- TIMER START
        Timer1.Interval = 50
        Timer1.Start()
         ' -------------------------------------------------------- 
        EventsAreEnabled = True
        Refresh()
        Opacity = 1
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        ReduceVolumeAndStop()
        Save_INI()
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub

    Friend Sub ReduceVolumeAndStop()
        ' ----------------------------------------------------------------- reduce smoothly the volume
        wp1.PlayPrepareForStop()
        ' ----------------------------------------------------------------- wait to avoid closing noise
        Dim waittime As Int32 = 0
        waittime = Math.Max(waittime, wp1.GetTotalDelayMillisec)
        Threading.Thread.Sleep(waittime + 10)
        ' ----------------------------------------------------------------- and close
        wp1.PlayStopImmediate()
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Return
        LimitFormPosition(Me)
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If Not EventsAreEnabled Then Return
        Dim n As Int32
        Dim f As Single
        If SlotWave >= 0 Then
            n = CInt(Slots.ReadSlot_NoNan(SlotWave) / 1000 * 6)
            If n <> cmb_Gen1_Wave.SelectedIndex Then
                Combo_SetIndex(cmb_Gen1_Wave, n)
                WaveGenSetWaveTypes()
            End If
        End If
        If SlotFreq >= 0 Then
            f = Slots.ReadSlot_NoNan(SlotFreq)
            wp1.SetFrequency(f)
            txt_Gen1_Freq.NumericValue = f
        End If
        If SlotDB >= 0 Then
            n = CInt((Slots.ReadSlot_NoNan(SlotDB) - 1000) / 10)
            If n <> txt_Gen1_dB.NumericValueInteger Then
                txt_Gen1_dB.NumericValueInteger = n
                WaveGenTrim()
            End If
        End If
        If SlotPan >= 0 Then
            n = CInt((Slots.ReadSlot_NoNan(SlotPan) - 500) / 5)
            If n <> txt_Gen1_Pan.NumericValueInteger Then
                txt_Gen1_Pan.NumericValueInteger = n
                WaveGenTrim()
            End If
        End If
    End Sub


    ' ===================================================================================================
    '  SELECT AUDIO OUTPUT 
    ' ===================================================================================================
    Friend SelectedAudioOut As Int32 = 0
    Private Sub cmb_AudioOutDevices_DropDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_AudioOutDevices.DropDown
        cmb_AudioOutDevices.ItemHeight = 16
        FillAudioOutDevicesCombo()
    End Sub
    Private Sub ccmb_AudioOutDevices_DropDownClosed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_AudioOutDevices.DropDownClosed
        cmb_AudioOutDevices.ItemHeight = 11
        SelectedAudioOut = cmb_AudioOutDevices.SelectedIndex
        wp1.PlayStart(SelectedAudioOut)
    End Sub
    Private Sub FillAudioOutDevicesCombo()
        Dim sa As String() = WaveNative.GetOutputDevicesNames
        If sa.Length = 0 Then ReDim sa(0) : sa(0) = ""
        cmb_AudioOutDevices.Items.Clear()
        For i As Int32 = 0 To sa.Length - 1
            cmb_AudioOutDevices.Items.Add(ExtractDeviceName(sa(i)))
        Next
        Combo_SetIndex(cmb_AudioOutDevices, SelectedAudioOut)
    End Sub

    ' ===================================================================================================
    '  AUDIO IN OUT HELPERS
    ' ===================================================================================================
    Private Sub btn_AudioOutputs_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_AudioOutputs.ClickButtonArea
        Open_AudioOutputs()
    End Sub
    Private Function ExtractDeviceName(ByVal s As String) As String
        If s = Nothing Then Return ""
        Dim i As Int32 = InStr(s, "(") - 1
        If i > 1 Then s = s.Remove(i)
        Return s.Trim
    End Function


    ' ===================================================================================================
    '  USER PARAMS 
    ' ===================================================================================================
    Private Sub SaveParamsOnLostFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                            Handles chk_Gen1.LostFocus, _
                                                                    cmb_Gen1_Wave.LostFocus, _
                                                                    txt_Gen1_Freq.LostFocus, _
                                                                    txt_Gen1_dB.LostFocus, _
                                                                    txt_SlotWave.LostFocus, _
                                                                    txt_SlotFreq.LostFocus, _
                                                                    txt_SlotDB.LostFocus, _
                                                                    txt_SlotPan.LostFocus
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub

    Private Sub txt_Gen1Freq_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_Gen1_Freq.TextChanged
        If Not EventsAreEnabled Then Return
        If SlotFreq > 0 Then Return
        Dim txt As CustomControlsLib.MyTextBox
        txt = DirectCast(sender, CustomControlsLib.MyTextBox)
        If txt.NumericValue >= 1000 Then
            txt.Decimals = 0
            txt.ArrowsIncrement = 100
            txt.Increment = 1
            txt.RoundingStep = 100
        ElseIf txt.NumericValue >= 100 Then
            txt.Decimals = 0
            txt.ArrowsIncrement = 10
            txt.Increment = 1
            txt.RoundingStep = 10
        Else
            txt.Decimals = 0
            txt.ArrowsIncrement = 1
            txt.Increment = 1
            txt.RoundingStep = 0
        End If
        WaveGenTrim()
    End Sub


    Private Sub chk_Gen1_enable_CheckedChanged(ByVal Sender As Object, ByVal e As System.EventArgs) Handles chk_Gen1.CheckedChanged
        If Not EventsAreEnabled Then Return
        If chk_Gen1.Checked Then
            wp1.PlayStart(SelectedAudioOut)
        Else
            wp1.PlayStop()
        End If
    End Sub
    Private Sub cmb_Gen1_Wave_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Gen1_Wave.DropDown
        CType(sender, ComboBox).ItemHeight = 16
    End Sub
    Private Sub cmb_Gen1_Wave_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Gen1_Wave.DropDownClosed
        CType(sender, ComboBox).ItemHeight = 12
    End Sub
    Private Sub cmb_Gen1_Wave_SelectionChangeCommitted(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Gen1_Wave.SelectionChangeCommitted
        If Not EventsAreEnabled Then Return
        WaveGenSetWaveTypes()
    End Sub
    Private Sub WaveGenSetWaveTypes()
        wp1.SetWaveType(CType(cmb_Gen1_Wave.SelectedIndex, WavePlayer.WaveTypes))
    End Sub
    Private Sub txt_Gen1_dB_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_Gen1_dB.TextChanged
        If Not EventsAreEnabled Then Return
        WaveGenTrim()
    End Sub
    Private Sub txt_Gen1_Pan_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_Gen1_Pan.TextChanged
        If Not EventsAreEnabled Then Return
        WaveGenTrim()
    End Sub
    Private Sub WaveGenTrim()
        wp1.SetFrequency(CSng(txt_Gen1_Freq.NumericValue))
        wp1.SetOutLevel(txt_Gen1_dB.NumericValueInteger)
        wp1.SetPan(txt_Gen1_Pan.NumericValueInteger)
    End Sub

    Private SlotWave As Int32 = -1
    Private SlotFreq As Int32 = -1
    Private SlotDB As Int32 = -1
    Private SlotPan As Int32 = -1
    Private Sub txt_Slots_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                            Handles txt_SlotWave.TextChanged, _
                                                                    txt_SlotFreq.TextChanged, _
                                                                    txt_SlotDB.TextChanged, _
                                                                    txt_SlotPan.TextChanged
        If Not EventsAreEnabled Then Return
        InitSlots()
    End Sub
    Private Sub InitSlots()
        SlotWave = txt_SlotWave.NumericValueInteger
        SlotFreq = txt_SlotFreq.NumericValueInteger
        SlotDB = txt_SlotDB.NumericValueInteger
        SlotPan = txt_SlotPan.NumericValueInteger
        If SlotWave < 0 Then
            cmb_Gen1_Wave.BackColor = Color.MintCream
        Else
            cmb_Gen1_Wave.BackColor = Color.FromArgb(220, 220, 220)
        End If
        cmb_Gen1_Wave.Enabled = SlotWave < 0
        txt_Gen1_Freq.Enabled = SlotFreq < 0
        txt_Gen1_dB.Enabled = SlotDB < 0
        txt_Gen1_Pan.Enabled = SlotPan < 0
    End Sub

End Class
